#!/usr/local/bin/perl

###  IMPORTANT:  You may need to **CHANGE** the path to Perl above
###  to point to where Perl actually is on your server.

###  Also, you may have to put the full system path to cgi-lib.pl
###  in below.  For example "/home/users/yourlogin/cgi-bin/cgi-lib.pl"
require "cgi-lib.pl";

&ReadParse(*input);
#########################################################################
#####									#
##### Chat-N-Time v1.0							#
##### Copyright 1997, Kristina L. Pfaff-Harris, kristina@tesol.net	#
#####									#
##### A very simple real-time chat program for the web.  Users log 	#
##### in and from then on can type messages in a box that appear	#
##### instantly to others in the "room."  A "refresh" tag insures that	#
##### the conversation keeps getting updated for others.  Uses frames.	#
#####									#
#########################################################################
#####									#
##### Licensing:							#
#####									#
#####  This program may be distributed free of charge for non-          #
#####  commercial use as long as the files chatntime.cgi, chatntime.html#
#####  chatntime.rules.html and cgi-lib.pl are included and as long as  #
#####  all headers remain intact.  					#
#####									#
#####  If you are a commercial website developer, please leave 		#
#####  my credit lines in the html files.  If you absolutely can't have #
#####  my credit as a link, please put it in comment format in the      #
#####  source code like this:                                           # 
#####									#
#####  <!-- Chat-N-Time v1.0 Copyright 1997 Kristina Pfaff-Harris -->   #
#####  <!-- Get it at http://www.linguistic-funland.com/scripts/    --> #
#####                                                                   #
#########################################################################
#####                                                                   #
##### IMPORTANT INSTRUCTIONS:                                           #
#####                                                                   #
##### In this program, I have put **CHANGE** in all the places where    #
##### you will need to modify the program to run on your server, so     #
##### that you can easily find all the places where changes are         #
##### necessary.  This program must be chmod 755 or 775 in order to     #
##### work, and the chatntime.html must be chmod 644.  Note:  on some   #
##### systems, you'll have create the file "chatntime.list.html" and 	#
##### make it world writeable (chmod 666).  Mostly, though, the program #
##### will create it if the directory it is in is writeable by the web 	#
##### server.								#
#####                                                                   #
##### In addition, you must be able to run cgi programs on your server.	#
#####                                                                   #
#########################################################################
#####                                                                   #
#####   Modification, copying, or distribution of this program          #
#####   for commercial use is strictly prohibited without permission    #
#####   from the author.  In other words, don't sell my program!        #
#####   Commercial web developers, please see the Licensing section     #
#####   above.                                                          #
#####   This program is offered as-is with no warranty either           #
#####   express or implied.  The user of this program agrees            #
#####   by such use to indemnify the author for any security            #
#####   breach, damage or loss caused in whole or in part by            #
#####   this program.                                                   #
#####                                                                   #
#########################################################################

######     Begin Configuration Section ######

# $path_to_chatntime_cgi is the full URL path to the chatntime.cgi
# program on your server.  This probably should begin with "http://".
# If all your files are in the same directory, you might be able to just
# leave this as it is below.  If not, **CHANGE** what's inside the ""
# to point to the chatntime.cgi file on your server.

$path_to_chatntime_cgi = "chatntime.cgi";

# $url_of_chat_file is the full URL of the file where you 
# want the program to keep track of the conversation. (What actually
# gets shown in the chat room.)  This should also probably 
# **CHANGE** this to the url of this file on your server.  You may
# be able to leave this as-is on some systems.

$url_of_chat_file = "http://www.tesol.net/scripts/Chat/chatntime.list.html";

# $path_to_chat_file is the full system path to the file where you 
# want the program to keep track of the conversation. (The same as
# the one we just got the URL for.)  This is NOT a URL, and must NOT
# begin with "http://".  Instead, it should probably look something
# like "/home/users/yourlogin/cgi-bin/chatntime.list.html".  **CHANGE** this to 
# the full system path of that file on your server. Again, if all your
# files are in the same directory, you may be able to leave this as-is,
# so try that first. :)

$path_to_chat_file = "chatntime.list.html";

# $number_of_chats_to_display is just how many lines you want to display
# of the ongoing chat before the program drops one off the end.  For 
# example, if you make this "5", then 5 people will get to say something,
# then when the 6th person says something, the 1st person's statement
# will drop off the list.  **CHANGE** this if you like to something
# longer or shorter.

$number_of_chats_to_display = "20";

# $chat_window_header is the HTML header that you want for the page that
# contains the chat window (the window where the "conversation is".  You
# can use any HTML code you like.  HOWEVER (and this is very important)
# don't insert the initial tags <HTML><HEAD>, since this chat program
# puts them in later.  Just sort of follow the example below.  You may
# **CHANGE** this to HTML code of your choice, but be aware (and this is
# also very important) that if you use the following characters: $,@,",\
# you must put a \ (backslash) in front of them like this:
# <a href=\"http://www.whatever.net\">soandso\@wherever.net</a>

$chat_window_header = "
<title>Chat window</title>
</head>
<body bgcolor=#FFFFFF>
<strong><center>Welcome to the Chat room!</center></strong>

"; #<-- This quote and semicolon are necessary. Don't backslash them!

# $chat_window_footer is the HTML footer that you want for the page that
# contains the chat window (the window where the "conversation is").  You
# can use any HTML code you like.  HOWEVER, you must abide by the 
# backslashing rules as with the chat_window_header above.  **CHANGE**
# this if you wish.

$chat_window_footer = "

<hr><font size=-2>Chat-N-Time v1.0 Copyright 1997 Kristina Pfaff-Harris
and can be found at <a href=http://www.linguistic-funland.com/scripts/>
http://www.linguistic-funland.com/scripts</a>.</font>
</body></html>

"; #<-- This quote and semicolon are necessary. Don't backslash them!

# $form_window_header is the HTML header for the frame where the form
# is that you type in to "talk".  Again, you may **CHANGE** this but
# be careful of special characters.

$form_window_header = "

<html><head><title>Chat-N-Time v1.0</title></head>
<body bgcolor=#FFFFFF>

"; #<-- This quote and semicolon are necessary. Don't backslash them!

# $form_window_footer is the HTML footer for the frame where the form
# is that you type in to "talk".  Again, you may **CHANGE** this but
# be careful of special characters.

$form_window_footer = "

<hr><font size=-2>Chat-N-Time v1.0 Copyright 1997 Kristina Pfaff-Harris
and can be found at <a href=http://www.linguistic-funland.com/scripts/>
http://www.linguistic-funland.com/scripts</a>.</font>
</body></html>

"; #<-- This quote and semicolon are necessary. Don't backslash them!

#####  End Configuration Section #####
####
#### You should not need to change anything beyond this point, but
#### you can look through it if you like that sort of thing. --kristina
########################################################################
print "Content-type: text/html\n\n";
  if ($input{'FAKE'} ne ""){
	 &chat;
	 }
  elsif ($input{'Login'} ne ""){
  print "$form_window_header
	<center>
        <table border=0>
	<tr><td bgcolor=#000000><font size=+1 color=#FFFFFF>
	<b>Talk to us, $input{'Login'}!</font>
	<td><base target=\"listen\">
	<form action=\"$path_to_chatntime_cgi\" method=\"post\">
	<input type=hidden name=Login value=\"$input{'Login'}\">
	<input type=hidden name=FAKE value=\"I sez\">
	<textarea name=\"Sez\" rows=2 cols=45></textarea>
	<center>
	<td><table border=1><tr><td>
	<input type=\"submit\" value=\"Say what?\"></td><td>
	<input type=reset value=\"Clear text box\"></center></td></tr></form>

	<base target=\"talk\">
	<form method=GET action=$path_to_chatntime_cgi>
	<input type=hidden name=Login value=$input{'Login'}>
	<tr><td><input type=submit value=\"Refresh top\"></td>
	</form>
	<base target=\"listen\">
	<form method=GET action=$url_of_chat_file>
	<input type=hidden name=Login value=$input{'Login'}>
	<td><input type=submit value=\"Refresh bottom\"></td></tr>
	</table></tr></table></form></center>$form_window_footer";
	}
   else {
      print "$form_window_header
	<form action=\"$path_to_chatntime_cgi\" method=\"post\">";
	print "<b>Please log in:</b><input type=text name=Login size=25><br>";
	print "<input type=submit value=\"Log in!\"></form>
	$form_window_footer";
       }

sub chat {

  &get_date;

  $login = $input{'Login'};
  $text = $input{'Sez'};
  if($text eq ""){$text = "&lt;just sitting here&gt;";}
  undef $/; # get more than one paragraph
  open(FILE, "$path_to_chat_file");

    @entries = split("<!-- Statement -->", <FILE>); 
 				# We assume that there is <!-- Statement -->
  			        # between each "statement" because we put
				# it there. :)
  close(FILE); 

# Now, we can get any entry in "@entries" by calling them by number.
# this way, we can print only $number_of_chats_to_display to the file later.

  # Try to open a file that holds the statements everyone has been making
  open(FILE, ">$path_to_chat_file");

# Now, we've opened the file, but let's make sure it refreshes the next time.

  print FILE "<HTML><HEAD>
	     <META HTTP-EQUIV=Refresh Content=\"10;URL=$url_of_chat_file?Login=$login\">
	     $chat_window_header<center><table border=1 width=75%>
	     <tr><td><!-- Statement -->";

# Don't allow them to put in html code:
   $login =~ s/</&lt;/g; $login =~ s/>/&gt;/g;
   $text =~ s/</&lt;/g; $text =~ s/>/&gt;/g;
  # Put the new info in.
  print FILE "[$date] <strong>$login:</strong> <i> $text</i><br>";  
  print FILE "<!-- Statement -->\n";

# Now, we're going to step through the previous entries, and print them
# back to the file:

# Starting with 1, until $i is equal to 10, add 1 to $i and keep looping...
  for($i = 1; $i <= $number_of_chats_to_display; $i++){
	$entries[$i] =~ s/\n//g;
	print FILE "$entries[$i]<!-- Statement -->\n" if $entries[$i] ne "";
  }


  # Close the document cleanly.
  print FILE "</td></tr></table>$chat_window_footer";
  close(FILE);

  # Now display it...
  # Get the contents of that file into a variable.  Could also have used
  # $file = `cat list.html`;

  undef $/; open(FILE, "$path_to_chat_file"); 
  $file = <FILE>; close(FILE); $/="\n";

  # and print the contents of the file to the screen.

  print "$file";
  exit();
}


sub get_date {

   ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
   $mon = $mon + 1;
   if ($hour < 10) { $hour = "0$hour"; }
   if ($min < 10) { $min = "0$min"; }
   if ($sec < 10) { $sec = "0$sec"; }

   $date = "$mon/$mday/$year $hour\:$min\:$sec";

}
